extends KinematicBody2D

const MOVE_SPEED = 300

onready var ray = $RayCast2D
onready var label = $Label

func _ready() -> void:
	pass # Replace with function body.

func _process(delta: float) -> void:
	label.text = "%3.f"%ray.rotation_degrees

func _physics_process(delta: float) -> void:
	var v:Vector2
	if Input.is_action_pressed("ui_left"):
		v.x = -1
	if Input.is_action_pressed("ui_up"):
		v.y = -1
	if Input.is_action_pressed("ui_right"):
		v.x = 1
	if Input.is_action_pressed("ui_down"):
		v.y = 1
	if v.length() == 0:
		return
	
	v = v.normalized()
	v *= MOVE_SPEED
	move_and_slide(v)

	var a = ray.rotation_degrees
	var b = rad2deg(atan2(v.y, v.x))
	ray.rotation_degrees += _diff_angle(a, b) * 0.1

# 最短の角度差を求める
# @param now 現在の角度
# @param next 目標となる角度
func _diff_angle(now:float, next:float) -> float:
	var d = next - now
	d -= floor(d / 360.0) * 360.0
	if d > 180:
		d -= 360
	return d
